MCBarrierEngine< RNG, S > Class Template Reference
Pricing engines » Barrier option engines

Pricing engine for barrier options using Monte Carlo simulation. More...

`#include <ql/pricingengines/barrier/mcbarrierengine.hpp>`

Inheritance diagram for MCBarrierEngine< RNG, S >:
[legend]

## Public Types

typedef McSimulation< SingleVariate, RNG, S >::path_generator_type | path_generator_type
typedef McSimulation< SingleVariate, RNG, S >::path_pricer_type | path_pricer_type
typedef McSimulation< SingleVariate, RNG, S >::stats_type | stats_type
Public Types inherited from Observer
typedef std::set< boost::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator
Public Types inherited from McSimulation< SingleVariate, RNG, S >
typedef MonteCarloModel< SingleVariate, RNG, S >::path_generator_type | path_generator_type
typedef MonteCarloModel< SingleVariate, RNG, S >::path_pricer_type | path_pricer_type
typedef MonteCarloModel< SingleVariate, RNG, S >::stats_type | stats_type
typedef MonteCarloModel< SingleVariate, RNG, S >::result_type | result_type

## Public Member Functions

| MCBarrierEngine (const boost::shared_ptr< GeneralizedBlackScholesProcess > &process, Size timeSteps, Size timeStepsPerYear, bool brownianBridge, bool antitheticVariate, Size requiredSamples, Real requiredTolerance, Size maxSamples, bool isBiased, BigNatural seed)
void | calculate () const
Public Member Functions inherited from GenericEngine< BarrierOption::arguments, BarrierOption::results >
PricingEngine::arguments * | getArguments () const
const PricingEngine::results * | getResults () const
void | reset ()
void | update ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()
Public Member Functions inherited from McSimulation< SingleVariate, RNG, S >
result_type | value (Real tolerance, Size maxSamples=QL_MAX_INTEGER, Size minSamples=1023) const
| add samples until the required absolute tolerance is reached
result_type | valueWithSamples (Size samples) const
| simulate a fixed number of samples
result_type | errorEstimate () const
| error estimated using the samples simulated so far
const stats_type & | sampleAccumulator (void) const
| access to the sample accumulator for richer statistics
void | calculate (Real requiredTolerance, Size requiredSamples, Size maxSamples) const
| basic calculate method provided to inherited pricing engines

## Protected Member Functions

TimeGrid | timeGrid () const
boost::shared_ptr< path_generator_type > | pathGenerator () const
boost::shared_ptr< path_pricer_type > | pathPricer () const
Protected Member Functions inherited from BarrierOption::engine
bool | triggered (Real underlying) const
Protected Member Functions inherited from McSimulation< SingleVariate, RNG, S >
| McSimulation (bool antitheticVariate, bool controlVariate)
virtual boost::shared_ptr< path_pricer_type > | controlPathPricer () const
virtual boost::shared_ptr< path_generator_type > | controlPathGenerator () const
virtual boost::shared_ptr< PricingEngine > | controlPricingEngine () const
virtual result_type | controlVariateValue () const

## Protected Attributes

boost::shared_ptr< GeneralizedBlackScholesProcess > | process_
Size | timeSteps_
Size | timeStepsPerYear_
Size | requiredSamples_
Size | maxSamples_
Real | requiredTolerance_
bool | isBiased_
bool | brownianBridge_
BigNatural | seed_
Protected Attributes inherited from GenericEngine< BarrierOption::arguments, BarrierOption::results >
BarrierOption::arguments | arguments_
BarrierOption::results | results_
Protected Attributes inherited from McSimulation< SingleVariate, RNG, S >
boost::shared_ptr< MonteCarloModel< SingleVariate, RNG, S > > | mcModel_
bool | antitheticVariate_
bool | controlVariate_

## Additional Inherited Members

Static Protected Member Functions inherited from McSimulation< SingleVariate, RNG, S >
static Real | maxError (const Sequence &sequence)
static Real | maxError (Real error)

## Detailed Description

### template<class RNG = PseudoRandom, class S = Statistics>
class QuantLib::MCBarrierEngine< RNG, S >

Pricing engine for barrier options using Monte Carlo simulation.

Uses the Brownian-bridge correction for the barrier found in Going to Extremes: Correcting Simulation Bias in Exotic Option Valuation - D.R. Beaglehole, P.H. Dybvig and G. Zhou Financial Analysts Journal; Jan/Feb 1997; 53, 1. pg. 62-68 and Simulating path-dependent options: A new approach - M. El Babsiri and G. Noel Journal of Derivatives; Winter 1998; 6, 2; pg. 65-83

Tests:
  the correctness of the returned value is tested by reproducing results available in literature.